-- For semi-automatic weapons with a limited RoundCount
-- No Bayonet

function Create(self)

	self.lastCount = 0;

	self.fireLength = 1500;
	self.fireSpacing = 4;

	self.hipSpread = 15; -- Inaccuracy when fired from hip (degrees!)
	self.aimSpread = 2.5; -- Inaccuracy when fired while sharp-aiming (degrees!)

	self.hipSpread = (self.hipSpread/360)*math.pi;
	self.aimSpread = (self.aimSpread/360)*math.pi;
	self.hipSpreadH = self.hipSpread*(-0.5);
	self.aimSpreadH = self.aimSpread*(-0.5);

	if self.Magazine ~= nil then
		self.lastCount = self.Magazine.RoundCount;
	end

	print("Nanocarbine Online!");
end

function Update(self)

	if self:IsActivated() and self.Magazine ~= nil and self.Magazine.RoundCount ~= self.lastCount and self.lastCount ~= 0 then
		self.lastCount = self.Magazine.RoundCount;

		local negativeNum = 1;
		if self.HFlipped == true then
			negativeNum = -1;
		end

		local flashPar = CreateMOPixel("Nanocarbine Muzzle");
		flashPar.Pos = self.MuzzlePos;
		flashPar.RotAngle = self.RotAngle;
		flashPar.HFlipped = self.HFlipped;
		MovableMan:AddParticle(flashPar);
		print("Spawning Muzzleflash");
		
		local beamDirection = self.RotAngle;

		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) and ToActor(actor):GetController():IsState(Controller.AIM_SHARP) then
			beamDirection = beamDirection + self.aimSpreadH + (math.random()*self.aimSpread);
		else
			beamDirection = beamDirection + self.hipSpreadH + (math.random()*self.hipSpread);
		end

		local beamLength = self.fireLength;

		local beamAmount = math.floor(beamLength/self.fireSpacing);

		local rayHit = false;
		local laserPointVector = self.MuzzlePos;
		local rayLengthA = 0;
		local rayLengthB = 0;
		for i = 1, beamAmount do
			rayLengthB = rayLengthA;
			rayLengthA = (i/beamAmount)*beamLength;
			local checkPos = self.MuzzlePos + Vector(rayLengthA*negativeNum,0):RadRotate(beamDirection);
			if SceneMan.SceneWrapsX == true then
				if checkPos.X > SceneMan.SceneWidth then
					checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
				elseif checkPos.X < 0 then
					checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
				end
			end
			laserPointVector = checkPos;
			if SceneMan:GetTerrMatter(checkPos.X,checkPos.Y) ~= 0 then
				rayHit = true;
				beamAmount = i;
				break;
			else
				local checkMOPix = SceneMan:GetMOIDPixel(checkPos.X,checkPos.Y);
				if checkMOPix ~= 255 then
					local checkObject = MovableMan:GetMOFromID(MovableMan:GetMOFromID(checkMOPix).RootID);
					if checkObject.Team ~= self.Team then
						rayHit = true;
						beamAmount = i;
						break;
					end
				end
			end
		end

		for i = 1, beamAmount do
			local particle = CreateAEmitter("Nanocarbine Hit Spark");
			local checkPos = self.MuzzlePos + Vector(i*self.fireSpacing*negativeNum,0):RadRotate(beamDirection);
			if SceneMan.SceneWrapsX == true then
				if checkPos.X > SceneMan.SceneWidth then
					checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
				elseif checkPos.X < 0 then
					checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
				end
			end
			particle.Pos = checkPos;
			particle.Vel = Vector(0,0);
			particle.Team = self.Team;
			particle.IgnoresTeamHits = true;
			--MovableMan:AddMO(particle);
			--print("Spawning Beam Particle");
		end

		if rayHit == true then
			local particle = CreateAEmitter("Nanocarbine Hit Spark");
			particle.Pos = laserPointVector;
			particle.Vel = Vector(0,0);
			particle.Team = self.Team;
			particle.IgnoresTeamHits = true;
			MovableMan:AddMO(particle);
			print("Spawning Hit Particle");
		end
	else
		if self.lastCount == 0 and self.Magazine ~= nil then
			self.lastCount = self.Magazine.RoundCount;
		end
	end
end
